/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
var EXPORT_REGEX_PATTERN = /(?:^|\n)\s*export\s+[a-zA-Z_]*\s+[a-zA-Z1-9_]*/g;
var IMPORT_REGEX = /(?:^|\n)\s*import\s+([{}a-zA-Z1-9,_\s]*)\s+from\s+['|"].*['|"]/g;
var MODULE_VERSION_URL_REGEX = /[a-zA-Z0-9-]*@[0-9]*\.[0-9]*\.[0-9]*\.*/;
var DEFAULT_SUPPORTED_MODULES = ['vue', 'whatwg-fetch'];
var DEFAULT_NAME = '_default';
var SCRIPT_TAG = 'script';
var MODULE_URL = 'https://unpkg.com/';

exports.default = {
    EXPORT_REGEX_PATTERN: EXPORT_REGEX_PATTERN,
    IMPORT_REGEX: IMPORT_REGEX,
    DEFAULT_SUPPORTED_MODULES: DEFAULT_SUPPORTED_MODULES,
    DEFAULT_NAME: DEFAULT_NAME,
    SCRIPT_TAG: SCRIPT_TAG,
    MODULE_URL: MODULE_URL,
    MODULE_VERSION_URL_REGEX: MODULE_VERSION_URL_REGEX
};

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _consts = __webpack_require__(0);

var _consts2 = _interopRequireDefault(_consts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var domain = null;
var supportedModules = _consts2.default.DEFAULT_SUPPORTED_MODULES;
var debug = false;
var cacheAll = false;
var cacheModules = true;
var compileSingle = true;
var moduleConfig = {};

var importScript = Array.from(document.getElementsByTagName('script')).find(function (elem) {
    return elem.getAttribute('import') != null;
});
if (importScript == null) {
    throw new Error('No import script found');
}

setup(importScript);

exports.default = {
    importScript: importScript,
    domain: domain,
    supportedModules: supportedModules,
    debug: debug,
    cacheAll: cacheAll,
    cacheModules: cacheModules,
    compileSingle: compileSingle,
    moduleConfig: moduleConfig,
    setup: setup

    /**
     * Setup
     * 
     * @param {HTMLElement} importScript 
     */
};
function setup(importScript) {
    var customNpmModules = importScript.getAttribute('npm-modules');
    if (customNpmModules) {
        supportedModules = supportedModules.concat(parseCustomModules(customNpmModules));
    }
    debug = importScript.getAttribute('debug') === 'true' ? true : false;
    cacheAll = importScript.getAttribute('cache-all') === 'true' ? true : false;
    moduleConfig = loadModConfig(importScript);
    console.log(moduleConfig);
}

/**
 * 
 * 
 * @param {HTMLElement} importScript 
 * @returns {any}
 */
function loadModConfig(importScript) {
    return supportedModules.reduce(function (agg, mod) {
        var config = importScript.getAttribute(mod);
        if (config) {
            agg[mod] = parseConfig(config, mod);
        }
        return agg;
    }, {});
}

/**
 * 
 * 
 * @param {any} config 
 * @param {string} moduleName
 * @returns {{version: string, overideUrl: string, moduleName: string}}
 */
function parseConfig(config, moduleName) {
    if (config.indexOf('{') > -1) {
        return JSON.parse(config);
    }
    return config.split('&').reduce(function (agg, keyValue) {
        var kv = keyValue.split('=');
        agg[kv[0]] = kv[1];
        return agg;
    }, { moduleName: moduleName });
}
/**
 * 
 * 
 * @param {string} customNpmModules 
 * @returns {string[]}
 */
function parseCustomModules(customNpmModules) {
    if (customNpmModules.indexOf('[') > -1) {
        return JSON.parse(customNpmModules);
    }
    return customNpmModules.split(',').map(function (mod) {
        return mod.trim();
    });
}

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _config = __webpack_require__(1);

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    composePathParts: composePathParts,
    executeImport: excuteImport,
    getGlobalFunctions: getGlobalFunctions,
    log: log

    /**
     * Builds path partial
     *
     * @param {string} combined
     * @param {string} next
     * @param {number} index
     * @param {Array<string>} arr
     * @returns
     */
};
function composePathParts(combined, next, index, arr) {
    if (arr.length === index + 1) {
        return combined !== '' ? combined + '/' : combined;
    }
    if (!next) {
        return combined;
    } else if (!combined) {
        return next;
    }
    return [combined, next].join('/');
}

/**
 * Adds the input script to the DOM.
 * 
 * @param {string} script 
 * @param {HTMLElement} parent 
 * @returns {Promise<boolean>}
 */
function excuteImport(script, parent) {
    if (!window) {
        //TODO add node support for building and outputing this as a promise
    }
    var scriptTag = document.createElement('script');
    var blob = new Blob([script], {
        'type': 'application/javascript'
    });
    var url = URL.createObjectURL(blob);
    parent.appendChild(scriptTag);
    return new Promise(function (resolve) {
        scriptTag.onload = function () {
            resolve();
            console.log('loaded', scriptTag.src);
        };
        scriptTag.src = url;
    });
}

function log(msg) {
    if (!_config2.default.debug) {
        return;
    }
    msg = (typeof msg === 'undefined' ? 'undefined' : _typeof(msg)) === 'object' ? JSON.stringify(msg, null, 2) : msg;
    console.log(msg);
}

function getGlobalFunctions() {
    return '(function (global) {\n        let imports = {}\n\n        global.ei = {\n            import: importer,\n            export: exporter,\n            imports: imports\n        }\n\n        function exporter(path, key, obj) {\n            imports[path] = imports[path] || {}\n            imports[path][key] = obj\n        }\n\n        function importer(path, key) {\n            if (!imports[path]) {\n                console.error(\'unable to find module: \' + path)\n                console.log(\'Available Modules: \', Object.keys(imports))\n            }\n            if (key) {\n                return imports[path][key]\n            }\n            return imports[path]\n        }\n    })(window);\n';
}

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _consts = __webpack_require__(0);

var _consts2 = _interopRequireDefault(_consts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var finalScript = '';
var addedScripts = {};
var scripts = [];

exports.default = {
    addToFinalScript: addToFinalScript,
    getFinalScript: getFinalScript,
    scriptIsLoaded: scriptIsLoaded

    /**
     * Add To final script
     * 
     * @param {string} partial 
     * @param {string} path 
     */
};
function addToFinalScript(partial, path) {
    if (addedScripts[path]) {
        return;
    }
    scripts.push({ path: path, script: partial });
    finalScript += partial;
    addedScripts[path] = true;
}

/**
 * Gets the final script
 * 
 * @returns {string}
 */
function getFinalScript() {
    return finalScript;
}

function scriptIsLoaded(scriptPath) {
    return addedScripts[scriptPath] || false;
}

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
var IS_JSON_KEY = 'is_JSON';

exports.default = {
    setItem: setItem,
    getItem: getItem

    /**
     * Set item
     * 
     * @param {string} key 
     * @param {object|string} value 
     */
};
function setItem(key, value) {
    var isJSON = !(typeof value === 'string');
    if (!isJSON) {
        localStorage.setItem(key, value);
        return;
    }
    var saveValue = IS_JSON_KEY + JSON.stringify(value);

    localStorage.setItem(key, saveValue);
}

/**
 * Get item
 * 
 * @param {string} key 
 */
function getItem(key) {
    var found = localStorage.getItem(key);
    if (!found) {
        return null;
    }
    return found.indexOf(IS_JSON_KEY) === 0 ? JSON.parse(found.replace(IS_JSON_KEY, '')) : found;
}

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _Importer = __webpack_require__(6);

// Begin loading
new _Importer.Importer();

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Importer = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Import = __webpack_require__(7);

var _VuePipeline = __webpack_require__(8);

var _loader = __webpack_require__(9);

var _loader2 = _interopRequireDefault(_loader);

var _consts = __webpack_require__(0);

var _consts2 = _interopRequireDefault(_consts);

var _utils = __webpack_require__(2);

var _utils2 = _interopRequireDefault(_utils);

var _config = __webpack_require__(1);

var _config2 = _interopRequireDefault(_config);

var _store = __webpack_require__(4);

var _store2 = _interopRequireDefault(_store);

var _scriptHolder = __webpack_require__(3);

var _scriptHolder2 = _interopRequireDefault(_scriptHolder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BUILT_SCRIPT_KEY = 'ltl';

var Importer = exports.Importer = function () {
    function Importer() {
        _classCallCheck(this, Importer);

        _config2.default.importScript;
        _config2.default.domain = null;
        _scriptHolder2.default.addToFinalScript(_utils2.default.getGlobalFunctions(), 'global');
        this.beginImport(_config2.default.importScript.getAttribute('import'));
    }

    /**s
     * Begin file imports
     *
     * @param {string} scriptPath
     * @returns void
     *
     * @memberof Importer
     */


    _createClass(Importer, [{
        key: 'beginImport',
        value: function beginImport(scriptPath) {
            var _this = this;

            this.setDefaultDomain();
            if (scriptPath.indexOf('http') > -1) {
                _config2.default.domain = scriptPath.split('/').slice(0, 3).join('/');
                scriptPath = './' + scriptPath.split('/').slice(3).join('/');
            }
            var imp = new _Import.Import('import {} from \'' + scriptPath + '\'', this.getStartingPath());
            var start = performance.now();
            if (_config2.default.cacheAll) {
                this.loadFinalFromCache();
            }
            this.getScript(imp).then(function () {
                return _this.addScript();
            }).then(function () {
                _utils2.default.log(imp.getDependencyMap());
                var end = performance.now();
                var diff = end - start;
                console.log('It took ' + diff + ' milliseconds to load all scripts');
            });
        }

        /**
         * Sets the default domain.
         * 
         * @memberof Importer
         */

    }, {
        key: 'setDefaultDomain',
        value: function setDefaultDomain() {
            var htmlFileName = window.location.href.split('/').filter(function (pth) {
                return pth.indexOf('.html') > -1;
            })[0] || '____';
            _config2.default.domain = window.location.href.replace(htmlFileName, '');
            if (_config2.default.domain.slice(-1) === '/') {
                _config2.default.domain = _config2.default.domain.slice(0, -1);
            }
        }
    }, {
        key: 'loadFinalFromCache',
        value: function loadFinalFromCache() {
            var lastCompiled = _store2.default.getItem(BUILT_SCRIPT_KEY);
            if (!lastCompiled) {
                return;
            }
            this.loadedFromCache = atob(lastCompiled.text);
            console.log('loading from cache');
            _utils2.default.executeImport(this.loadedFromCache, document.head);
        }
    }, {
        key: 'addScript',
        value: function addScript() {
            var finalScript = _scriptHolder2.default.getFinalScript();
            if (this.loadedFromCache === finalScript) {
                console.log('Nothing changed');
                return Promise.resolve();
            }
            _store2.default.setItem(BUILT_SCRIPT_KEY, { text: btoa(finalScript) });

            if (this.loadedFromCache) {
                console.log('There are changes, notify user');
                _store2.default.setItem(BUILT_SCRIPT_KEY, { text: btoa(finalScript) });
                if (window.confirm("There is a new version of this application available. Do you want to refresh and use updated version?")) {
                    window.location.reload();
                    return;
                }
                console.log('user says no');
            }
            console.log('Loading script');
            return _utils2.default.executeImport(finalScript, document.head);
        }
    }, {
        key: 'getStartingPath',
        value: function getStartingPath() {
            // there is already a domain specified, we don't need to find entrance base path.
            if (_config2.default.domain) {
                return './';
            }
            var context = window.location.href.replace(window.location.host, '');
            if (context.split('/').length > 2) {
                var startingPath = context.split('/').slice(0, -1).join('/');
                console.log('startingPath', startingPath);
                return startingPath;
            }
            return './';
        }

        /**
         * Recursively loads all scripts.
         *
         * @param {Import} _import
         * @returns
         *
         * @memberof Importer
         */

    }, {
        key: 'getScript',
        value: function getScript(_import) {
            var _this2 = this;

            if (_scriptHolder2.default.scriptIsLoaded(_import.path)) {
                return Promise.resolve(true);
            }
            return _loader2.default.load(_import.path).then(function (fileText) {
                return _this2.processFile(_import, fileText);
            });
        }

        /**
         * build Import
         *
         * @param {Import} _import
         * @param {string} script
         *
         * @memberof Importer
         */

    }, {
        key: 'processFile',
        value: function processFile(_import, script) {
            script = new _VuePipeline.VuePipeline(_import.path, script).getConvertedText();
            script = this.processExports(_import, script);
            _import.script = this.processImports(_import, script);
            return this.loadDependencies(_import).then(function () {
                return _import.addScript();
            });
        }

        /**
         * Loads dependencies.
         *
         * @param {Import} _import
         * @returns {Promise<any>}
         * @memberof Importer
         */

    }, {
        key: 'loadDependencies',
        value: function loadDependencies(_import) {
            var _this3 = this;

            if (!_import.dependencies) {
                return Promise.resolve();
            }
            return Promise.all(_import.dependencies.map(function (nextImport) {
                return _this3.getScript(nextImport);
            }));
        }

        /**
         * Process exports
         *
         * @param {Import} _import
         * @param {string} script
         * @returns {string}
         *
         * @memberof Importer
         */

    }, {
        key: 'processExports',
        value: function processExports(_import, script) {
            var exports = this.getExports(_import.path, script);
            if (!exports) {
                return script;
            }
            script = script.replace(/export default /, 'const ' + _consts2.default.DEFAULT_NAME + ' = ');
            script = script.replace(/export /g, '');
            script = [script, exports.join('\n')].join('\n');
            return script;
        }

        /**
         * Process imports
         *
         * @param {Import} _import
         * @param {string} script
         * @returns {string}
         *
         * @memberof Importer
         */

    }, {
        key: 'processImports',
        value: function processImports(_import, script) {
            var imports = this.getImports(_import.path, script);
            if (!imports) {
                return script;
            }
            var importsText = imports.map(function (imp) {
                _import.addDependency(imp);
                return imp.getImportText();
            }).join('\n');
            script = script.replace(_consts2.default.IMPORT_REGEX, '');
            script = importsText + ' \n ' + script;
            return script;
        }

        /**
         * Gets the exports for a given file
         *
         * @param {string} scriptPath
         * @param {string} script
         * @returns {string[]}
         *
         * @memberof Importer
         */

    }, {
        key: 'getExports',
        value: function getExports(scriptPath, script) {
            var _this4 = this;

            var exports = script.match(_consts2.default.EXPORT_REGEX_PATTERN);
            if (!exports) {
                return null;
            }

            return exports.map(function (exp) {
                var _exp$trim$split = exp.trim().split(/\s+/),
                    _exp$trim$split2 = _slicedToArray(_exp$trim$split, 3),
                    _ = _exp$trim$split2[0],
                    varType = _exp$trim$split2[1],
                    name = _exp$trim$split2[2];

                if (varType === 'default') {
                    return _this4.getExportScript(scriptPath, _consts2.default.DEFAULT_NAME, _consts2.default.DEFAULT_NAME);
                }
                return _this4.getExportScript(scriptPath, name, name);
            });
        }
    }, {
        key: 'getExportScript',
        value: function getExportScript(scriptPath, name, objName) {
            return 'ei.export(\'' + scriptPath + '\', \'' + name + '\', ' + objName + ');';
        }

        /**
         * Gets the imports for a given file
         *
         * @param {string} scriptPath
         * @param {string} script
         * @returns {Import[]}
         *
         * @memberof Importer
         */

    }, {
        key: 'getImports',
        value: function getImports(scriptPath, script) {
            // TODO: allow 'imports as' syntax.
            var imports = script.match(_consts2.default.IMPORT_REGEX);
            if (!imports) {
                return null;
            }
            return imports.map(function (imp) {
                return new _Import.Import(imp, scriptPath);
            });
        }
    }]);

    return Importer;
}();

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Import = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _consts = __webpack_require__(0);

var _consts2 = _interopRequireDefault(_consts);

var _utils = __webpack_require__(2);

var _utils2 = _interopRequireDefault(_utils);

var _config = __webpack_require__(1);

var _config2 = _interopRequireDefault(_config);

var _scriptHolder = __webpack_require__(3);

var _scriptHolder2 = _interopRequireDefault(_scriptHolder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EXPORT_DEFAULT_REGEX = /ei\.export\('.*', '_default', _default\);/;

var Import = exports.Import = function () {
    /**
     * Creates an instance of Import.
     * @param {string} fullImportText 
     * 
     * @memberof Import
     */
    function Import(fullImportText, parentScriptPath) {
        _classCallCheck(this, Import);

        fullImportText = fullImportText.trim();
        this.variables = this.getVariables(fullImportText);
        var path = fullImportText.match(/["|'].*["|']/g)[0].replace(/["|']/g, "");
        this.path = this.buildRelativePath(path, parentScriptPath.replace(_config2.default.domain, ''));
        this.path = this.getActualPath(this.path);
        /**
         * @type {Array<Import>}
         */
        this.dependencies = [];
        /**
         * @type {string}
         */
        this.script = null;
    }

    /**
     * 
     * 
     * @param {string} path 
     * @returns 
     * @memberof Import
     */


    _createClass(Import, [{
        key: 'getActualPath',
        value: function getActualPath(path) {
            if (_config2.default.supportedModules.indexOf(path) > -1) {
                return '' + _consts2.default.MODULE_URL + path;
            }
            if (!this.hasExtension(path)) {
                path = path + '.js';
            }
            if (_config2.default.domain) {
                var cleanedPath = path.indexOf('.') === 0 ? path.substr(1) : path;
                cleanedPath = cleanedPath.indexOf('/') === 0 ? cleanedPath.slice(1) : cleanedPath;
                path = [_config2.default.domain, cleanedPath].join('/');
            }
            return path;
        }
    }, {
        key: 'hasExtension',
        value: function hasExtension(path) {
            var parts = path.split('.');
            if (!parts.length) {
                return false;
            }
            return parts[parts.length - 1].length < 5;
        }

        /**
         * Get a depency map
         * 
         * @returns any
         * @memberof Import
         */

    }, {
        key: 'getDependencyMap',
        value: function getDependencyMap() {
            var obj = {};
            obj[this.path] = this.dependencies.map(function (dep) {
                return dep.getDependencyMap();
            });
            return obj;
        }

        /**
         * 
         * 
         * @param {string} fullImportText 
         * @returns {{name: string, valueName: string}[]}
         * 
         * @memberof Import
         */

    }, {
        key: 'getVariables',
        value: function getVariables(fullImportText) {
            if (fullImportText.indexOf("{") === -1) {
                var _fullImportText$split = fullImportText.split(/\s+/),
                    _fullImportText$split2 = _slicedToArray(_fullImportText$split, 2),
                    _import = _fullImportText$split2[0],
                    defaultName = _fullImportText$split2[1];

                return [{
                    name: defaultName,
                    valueName: _consts2.default.DEFAULT_NAME
                }];
            }
            return fullImportText.match(/{([a-zA-Z1-9,_\s]*)}/g)[0].replace(/[{|}]/g, "").split(",").map(function (val) {
                return val.trim();
            }).filter(function (val) {
                return val !== "";
            }).map(function (val) {
                return {
                    name: val,
                    valueName: val
                };
            });
        }

        /**
         * 
         * 
         * @param {string} childPath 
         * @param {string} parentPath 
         * @returns 
         * 
         * @memberof Import
         */

    }, {
        key: 'buildRelativePath',
        value: function buildRelativePath(childPath, parentPath) {
            // in this case, we have an external url, don't need to build a path.
            if (childPath.includes("http") || _config2.default.supportedModules.indexOf(childPath) > -1) {
                return childPath;
            }

            var cds = childPath.match(/\.\.\//g);
            var cdLength = cds != null ? cds.length : 0;
            childPath = childPath.replace(/\.\.\//g, "");
            parentPath = parentPath || "/";
            var parentPathArray = parentPath.split("/");
            if (cdLength) {
                parentPathArray = parentPathArray.slice(0, -cdLength);
            }
            var path = parentPathArray.reduce(_utils2.default.composePathParts, "");
            return [path, childPath.replace("./", "")].join("");
        }

        /**
         * Gets the correct import text for the instance of the Import object
         * 
         * @returns {string}
         * @memberof Import
         */

    }, {
        key: 'getImportText',
        value: function getImportText() {
            var _this = this;

            return this.variables.map(function (variable) {
                return 'const ' + variable.name + ' = ei.import(\'' + _this.path + '\', \'' + variable.valueName + '\');';
            }).join("\n");
        }

        /**
         * Adds a child dependency to this import
         * 
         * @param {Import} _import 
         * 
         * @memberof Import
         */

    }, {
        key: 'addDependency',
        value: function addDependency(_import) {
            this.dependencies.push(_import);
        }

        /**
         * To keep the global scope unpolluted and ensure that exports and imports actually do what we expect, 
         * we need to wrap the entire script file in an iife.
         * 
         * @returns {string}
         * 
         * @memberof Import
         */

    }, {
        key: 'getIifeWrappedScript',
        value: function getIifeWrappedScript() {
            if (this.variables.length && this.script.indexOf("ei.export") === -1) {
                return this.getExternalModule(this.script);
            }
            return this.getIife(this.script);
        }
    }, {
        key: 'getExternalModule',
        value: function getExternalModule(content) {
            if (this.script.indexOf('typeof exports') > -1 && this.script.indexOf('typeof module') > -1) {
                var top = 'let exports = {};let module = {};';
                var bottom = this.script + ' \nei.export(\'' + this.path + '\', \'' + _consts2.default.DEFAULT_NAME + '\', module.exports)';
                return this.getIife(top + ';\n' + content + ';\n' + bottom);
            }
            var ex = this.variables[0];
            content = content + ' \nei.export(\'' + this.path + '\', \'' + _consts2.default.DEFAULT_NAME + '\', global.' + ex.name + ')';
            var global = "const global = window;";
            return this.getIife(global + '\n' + content);
        }
    }, {
        key: 'getIife',
        value: function getIife(content) {
            return '(function(){"use strict"\n' + content + '\n})();\n';
        }

        /**
         * Adds the input script to the DOM.
         * 
         * @returns {Promise<any>}
         */

    }, {
        key: 'addScript',
        value: function addScript() {
            if (_config2.default.compileSingle) {
                _scriptHolder2.default.addToFinalScript(this.getIifeWrappedScript(), this.path);
                return Promise.resolve();
            }
        }
    }]);

    return Import;
}();

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var VuePipeline = exports.VuePipeline = function () {

    /**
     * Creates an instance of VuePipeline.
     * 
     * @param {string} filePath 
     * @param {string} fullImportText 
     * @memberof VuePipeline
     */
    function VuePipeline(filePath, fullImportText) {
        _classCallCheck(this, VuePipeline);

        this.filePath = filePath;
        this.fullImportText = fullImportText;
    }

    /**
     * Get converted Text
     * 
     * @returns 
     * @memberof VuePipeline
     */


    _createClass(VuePipeline, [{
        key: 'getConvertedText',
        value: function getConvertedText() {
            if (this.filePath.indexOf('.vue') === -1) {
                return this.fullImportText;
            }
            var converted = this.processTemplate(this.fullImportText);
            if (converted.indexOf('<script src=') > -1) {
                return this.convertSrcScript(converted);
            }
            return this.convertScript(converted);
        }

        /**
         * Process Template
         * 
         * @param {string} converted 
         * @returns {string}
         * @memberof VuePipeline
         */

    }, {
        key: 'processTemplate',
        value: function processTemplate(converted) {
            var styleImport = '\n`;\nconst styleTag = document.createElement("style");\nstyleTag.innerHTML = styles;\ndocument.head.appendChild(styleTag)';
            converted = this.fullImportText.replace('<template>', 'const template = `').replace('</template>', '`');
            return converted.replace('<style>', 'let styles = `').replace('</style>', styleImport);
        }

        /**
         * Convert Source Script
         * 
         * @param {string} converted 
         * @returns {string}
         * @memberof VuePipeline
         */

    }, {
        key: 'convertSrcScript',
        value: function convertSrcScript(converted) {
            var _converted$split = converted.split('<script src='),
                _converted$split2 = _slicedToArray(_converted$split, 2),
                firstHalf = _converted$split2[0],
                secondHalf = _converted$split2[1];

            converted = firstHalf + '\nimport component from ' + secondHalf.replace('>', '');
            converted = converted + 'component.template = template;\nexport default component';
            converted = converted.replace('<script>', '').replace('</script>', '');
            return converted;
        }

        /**
         * Convert Script
         * 
         * @param {any} converted 
         * @returns 
         * @memberof VuePipeline
         */

    }, {
        key: 'convertScript',
        value: function convertScript(converted) {
            converted = converted.replace('<script>', '').replace('</script>', '');
            if (converted.indexOf('export default {') > -1) {
                return converted.replace('export default {', 'export default {\n template: template,');
            }
            return converted.replace('data()', 'template: template,\ndata()');
        }
    }]);

    return VuePipeline;
}();

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _config = __webpack_require__(1);

var _config2 = _interopRequireDefault(_config);

var _store = __webpack_require__(4);

var _store2 = _interopRequireDefault(_store);

var _consts = __webpack_require__(0);

var _consts2 = _interopRequireDefault(_consts);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var promises = {};


var refreshingCache = [];

exports.default = {
    load: loadFile,
    awaitCacheRefresh: awaitCacheRefresh
};


function loadFile(path) {
    // caching promises so we don't make requests multiple times.
    if (promises[path]) {
        return promises[path];
    }
    promises[path] = load(path);
    return promises[path];
}

/**
 * 
 * @param {string} path 
 * @returns 
 */
function load(path) {
    var moduleConfig = getModuleConfig(path);
    if (!shouldLoadFromCache(path)) {
        return getRemote(path, moduleConfig);
    }
    var fromCache = loadFromCache(path, moduleConfig);
    if (fromCache) {
        // refresh cache, but load instantly from cache since it is possible.
        refreshingCache.push({
            promise: getRemote(path, moduleConfig),
            config: moduleConfig
        });
        return Promise.resolve(fromCache);
    }
    return getRemote(path, moduleConfig).catch(function () {
        return loadFromCache(path, moduleConfig);
    });
}

function getModuleConfig(path) {
    if (!isModule(path)) {
        return {};
    }
    var moduleName = path.replace(_consts2.default.MODULE_URL, '');
    var moduleConfig = _config2.default.moduleConfig[moduleName] || { version: '' };
    return moduleConfig;
}

function isModule(path) {
    return path.indexOf(_consts2.default.MODULE_URL) === 0;
}

/**
 * @param {string} path 
 * @returns 
 */
function shouldLoadFromCache(path) {
    return _config2.default.cacheModules && isModule(path);
}

/**
 * Get Remote
 * s
 * @param {string} path 
 * @param {{version: string, overideUrl: string, moduleName: string}} moduleConfig 
 * @returns 
 */
function getRemote(path, moduleConfig) {
    var resp = null;
    var pth = getRemotePath(path, moduleConfig);
    return new Promise(function (resolve, reject) {
        var timeoutId = setTimeout(reject, 400);
        fetch(pth).then(function (response) {
            clearTimeout(timeoutId);
            if (!response.ok) {
                throw new Error(response.statusText);
            }
            resp = response;
            return response.text();
        }).then(function (text) {
            cache(path, text, resp, moduleConfig);
            resolve(text);
        }).catch(function (err) {
            clearTimeout(timeoutId);
            reject();
        });
    });
}

/**
 * 
 * 
 * @param {string} path 
 * @param {{version: string, overideUrl: string, moduleName: string}} moduleConfig 
 * @returns {string}
 */
function getRemotePath(path, moduleConfig) {
    if (moduleConfig.overideUrl) {
        return moduleConfig.overideUrl;
    }
    if (moduleConfig.version && moduleConfig.version !== '') {
        var versionName = [moduleConfig.moduleName, moduleConfig.version].join('@');
        return '' + _consts2.default.MODULE_URL + versionName;
    }
    return path;
}

/**
 * 
 * 
 * @param {string} path 
 * @param {string} text 
 * @param {Response} fullResponse 
 * @param {{version: string, overideUrl: string}} moduleConfig
 */
function cache(path, text, fullResponse, moduleConfig) {
    var version = moduleConfig.version;

    var loadedVersion = fullResponse.url.match(_consts2.default.MODULE_VERSION_URL_REGEX);
    if (loadedVersion) {
        version = loadedVersion[0].split('@')[1];
    }
    _store2.default.setItem(path, { text: btoa(text), url: fullResponse.url, version: version, overideUrl: moduleConfig.overideUrl });
}
/**
 * 
 * 
 * @param {any} path 
 * @returns {string}
 */
function loadFromCache(path, moduleConfig) {
    var found = _store2.default.getItem(path);
    if (!found || !found.text || !found.url) {
        return null;
    }
    if (moduleConfig.version !== 0 && found.version !== moduleConfig.version) {
        return null;
    }
    if (moduleConfig.overideUrl !== null && found.overideUrl !== moduleConfig.overideUrl) {
        return null;
    }
    if (_config2.default.debug) {
        console.log('Loaded ' + path + ' from cache');
    }
    return atob(found.text);
}

function awaitCacheRefresh() {
    var promise = refreshingCache.map(function (item) {
        return item.promise;
    });
    return Promise.all(promise).then(function (items) {
        return true;
    });
}

/***/ })
/******/ ]);